Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15017)
@@ -5,21 +5,17 @@
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Diagnostics;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
-
+  using Constants;
+  using Data.Pool;
+  using Extensions;
   using Interpreter;
-
-  public interface IMutablePushProgram {
-    void SetAtIndex(int index, Expression expression);
-  }
+  using Persistence.Default.CompositeSerializers.Storable;
 
   [Serializable]
   [StorableClass]
-  public sealed class PushProgram : Expression, IPooledObject, IMutablePushProgram {
+  public sealed class PushProgram : Expression, IPooledObject {
 #if DEBUG
-    private const int StringRepresentationCountBeforeAggregate = 50;
+    private const int STRING_REPRESENTATION_COUNT_BEFORE_AGGREGATE = 10;
 #else
-    private const int StringRepresentationCountBeforeAggregate = 10;
+    private const int STRING_REPRESENTATION_COUNT_BEFORE_AGGREGATE = 1;
 #endif
 
@@ -27,8 +23,8 @@
     public static readonly PushProgram Empty = new PushProgram();
 
-    private const string Prefix = "(";
-    private const string PrefixReduced = "[";
-    private const string Postfix = ")";
-    private const string PostfixReduced = "]";
+    private const string Prefix = PushEnvironment.ProgramStartSymbolStr + " ";
+    private const string Postfix = " " + PushEnvironment.ProgramEndSymbolStr;
+    private const string PrefixReduced = "|";
+    private const string PostfixReduced = "|";
     private const string Delimiter = " ";
 
@@ -112,4 +108,5 @@
     }
 
+    [NonSerialized]
     private string stringRepresentation;
     public override string StringRepresentation
@@ -117,10 +114,10 @@
       get
       {
-        if (stringRepresentation == null) stringRepresentation = BuildString();
-        return stringRepresentation;
-      }
-    }
-
-
+        return stringRepresentation ?? (stringRepresentation = BuildStringRepresentation());
+      }
+    }
+
+
+    [NonSerialized]
     private int? depth;
     public int Depth
@@ -133,4 +130,5 @@
     }
 
+    [NonSerialized]
     private int[] treeIndex;
     private int[] TreeIndex
@@ -138,20 +136,19 @@
       get
       {
-        if (treeIndex == null) treeIndex = BuildTreeIndex();
-        return treeIndex;
-      }
-    }
-
+        return treeIndex ?? (treeIndex = BuildTreeIndex());
+      }
+    }
+
+    [NonSerialized]
     private int? hashCode;
     public override int GetHashCode() {
-      if (hashCode == null) hashCode = HashExpressions();
+      if (hashCode == null) hashCode = expressions.HashCode();
       return hashCode.Value;
     }
 
-    void IMutablePushProgram.SetAtIndex(int index, Expression expression) {
-
-    }
-
     public override bool Equals(object obj) {
+      if (obj == null)
+        return false;
+
       if (ReferenceEquals(this, obj))
         return true;
@@ -183,4 +180,7 @@
       return StringRepresentation;
     }
+
+    [NonSerialized]
+    private int? totalCount;
 
     /// <summary>
@@ -192,8 +192,66 @@
       get
       {
-        return IsEmpty
+        if (totalCount == null) {
+          totalCount = IsEmpty
             ? 1
             // + 1 because "this" is also counted
             : TreeIndex[0] + 1;
+        }
+
+        return totalCount.Value;
+      }
+    }
+
+    [NonSerialized]
+    private int? totalExpressionCount;
+    /// <summary>
+    /// Returns the amount of none program expressions
+    /// </summary>
+    /// <returns></returns>
+    public int TotalExpressionCount
+    {
+      get
+      {
+        if (totalExpressionCount == null) {
+          totalExpressionCount = 0;
+
+          for (var i = 0; i < Count; i++) {
+            var expression = expressions[i];
+
+            totalExpressionCount += expression.IsProgram
+              ? ((PushProgram)expression).TotalExpressionCount
+              : 1;
+          }
+        }
+
+        return totalExpressionCount.Value;
+      }
+    }
+
+    [NonSerialized]
+    private int? branches;
+    /// <summary>
+    /// Returns the amount of branches in the whole tree. Even an empty program represents at least one branch
+    /// </summary>
+    /// <returns></returns>
+    public int Branches
+    {
+      get
+      {
+        if (branches == null) {
+          branches = 1;
+
+          for (var i = 0; i < Count; i++) {
+            var expression = expressions[i];
+
+            if (!expression.IsProgram)
+              continue;
+
+            var program = (PushProgram)expression;
+            branches += program.Branches;
+          }
+        }
+
+        return branches.Value;
       }
     }
@@ -247,10 +305,10 @@
 
     private int CalcDepth() {
-      var maxDepth = 1;
+      var maxDepth = 0;
       for (var i = 0; i < Count; i++) {
         var expression = expressions[i];
         if (!expression.IsProgram) continue;
+
         var expandExpression = (PushProgram)expression;
-
         if (expandExpression.Depth > maxDepth)
           maxDepth = expandExpression.Depth;
@@ -260,14 +318,13 @@
     }
 
-    private string BuildString() {
+    private string BuildStringRepresentation() {
       // prevent too big string
-      return TotalCount > StringRepresentationCountBeforeAggregate
+      return Count > STRING_REPRESENTATION_COUNT_BEFORE_AGGREGATE
         ? PrefixReduced + Count + PostfixReduced
-        : Prefix + string.Join(Delimiter, expressions) + Postfix;
+        : Prefix + string.Join(Delimiter, expressions.Reverse()) + Postfix;
     }
 
     private int[] BuildTreeIndex() {
-      var local_treeIndex = new int[Count];
-
+      var localTreeIndex = new int[Count];
       var next = 1;
 
@@ -275,5 +332,5 @@
         var subExpression = expressions[i];
 
-        local_treeIndex[i] = next;
+        localTreeIndex[i] = next;
 
         if (subExpression.IsProgram) {
@@ -284,15 +341,5 @@
       }
 
-      return local_treeIndex;
-    }
-
-    private int HashExpressions() {
-      var hash = 19 * 31 + typeof(PushProgram).GetHashCode();
-
-      for (var i = 0; i < Count; i++) {
-        hash = hash * 31 + expressions[i].GetHashCode();
-      }
-
-      return hash;
+      return localTreeIndex;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15017)
@@ -1,5 +1,9 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System.Collections.Generic;
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
@@ -101,5 +105,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
+      var size = interpreter.IntegerStack.Pop().AsInt(interpreter.Configuration.MaxPointsInRandomExpression);
       var program = LinearCodeGenerator.RandomProgram(
         interpreter.PoolContainer.PushProgramPool,
@@ -113,3 +117,103 @@
     }
   }
+
+  /// <summary>
+  ///     Pushes a random char.
+  /// </summary>
+  [PushExpression(StackTypes.Char, "CHAR.RAND")]
+  [StorableClass]
+  public class CharRandExpression : StatelessExpression {
+    public CharRandExpression() { }
+    [StorableConstructor]
+    protected CharRandExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return !interpreter.Configuration.ErcOptions.CharErcOptions.IsEnabled;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var value = interpreter.Configuration.ErcOptions.CharErcOptions.GetErcValue(interpreter.Random);
+      interpreter.CharStack.Push(value);
+    }
+
+    /// <summary>
+    ///     Pushes a random string.
+    /// </summary>
+    [PushExpression(StackTypes.String, "STRING.RAND")]
+    [StorableClass]
+    public class StringRandExpression : StatelessExpression {
+      public StringRandExpression() { }
+      [StorableConstructor]
+      protected StringRandExpression(bool deserializing) : base(deserializing) { }
+
+      public override bool IsNoop(IInternalPushInterpreter interpreter) {
+        return !interpreter.Configuration.ErcOptions.StringErcOptions.IsEnabled;
+      }
+
+      public override void Eval(IInternalPushInterpreter interpreter) {
+        var value = interpreter.Configuration.ErcOptions.StringErcOptions.GetErcValue(interpreter.Random);
+        interpreter.StringStack.Push(value);
+      }
+
+      /// <summary>
+      ///     Pushes a random interger vector.
+      /// </summary>
+      [PushExpression(StackTypes.IntegerVector, "INTEGER[].RAND")]
+      [StorableClass]
+      public class IntegerVectorRandExpression : StatelessExpression {
+        public IntegerVectorRandExpression() { }
+        [StorableConstructor]
+        protected IntegerVectorRandExpression(bool deserializing) : base(deserializing) { }
+
+        public override bool IsNoop(IInternalPushInterpreter interpreter) {
+          return !interpreter.Configuration.ErcOptions.IntegerVectorErcOptions.IsEnabled;
+        }
+
+        public override void Eval(IInternalPushInterpreter interpreter) {
+          var value = interpreter.Configuration.ErcOptions.IntegerVectorErcOptions.GetErcValue(interpreter.Random);
+          interpreter.IntegerVectorStack.Push(new List<long>(value.Select(i => (long)i)));
+        }
+      }
+
+      /// <summary>
+      ///     Pushes a random float vector.
+      /// </summary>
+      [PushExpression(StackTypes.FloatVector, "FLOAT[].RAND")]
+      [StorableClass]
+      public class FloatVectorRandExpression : StatelessExpression {
+        public FloatVectorRandExpression() { }
+        [StorableConstructor]
+        protected FloatVectorRandExpression(bool deserializing) : base(deserializing) { }
+
+        public override bool IsNoop(IInternalPushInterpreter interpreter) {
+          return !interpreter.Configuration.ErcOptions.FloatVectorErcOptions.IsEnabled;
+        }
+
+        public override void Eval(IInternalPushInterpreter interpreter) {
+          var value = interpreter.Configuration.ErcOptions.FloatVectorErcOptions.GetErcValue(interpreter.Random);
+          interpreter.FloatVectorStack.Push(value);
+        }
+      }
+
+      /// <summary>
+      ///     Pushes a random boolean vector.
+      /// </summary>
+      [PushExpression(StackTypes.StringVector, "STRING[].RAND")]
+      [StorableClass]
+      public class StringVectorRandExpression : StatelessExpression {
+        public StringVectorRandExpression() { }
+        [StorableConstructor]
+        protected StringVectorRandExpression(bool deserializing) : base(deserializing) { }
+
+        public override bool IsNoop(IInternalPushInterpreter interpreter) {
+          return !interpreter.Configuration.ErcOptions.StringVectorErcOptions.IsEnabled;
+        }
+
+        public override void Eval(IInternalPushInterpreter interpreter) {
+          var value = interpreter.Configuration.ErcOptions.StringVectorErcOptions.GetErcValue(interpreter.Random);
+          interpreter.StringVectorStack.Push(value);
+        }
+      }
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15017)
@@ -84,5 +84,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.ROT")]
+  [PushExpression(StackTypes.Exec, "EXEC.ROT", execIn: 3)]
   [StorableClass]
   public class ExecRotateExpression : RotateExpression<Expression> {
@@ -150,5 +150,5 @@
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].ROT")]
   [StorableClass]
-  public class IntegerVectorRotateExpression : RotateExpression<List<long>> {
+  public class IntegerVectorRotateExpression : RotateExpression<IReadOnlyList<long>> {
     public IntegerVectorRotateExpression() { }
     [StorableConstructor]
@@ -166,5 +166,5 @@
   [PushExpression(StackTypes.FloatVector, "FLOAT[].ROT")]
   [StorableClass]
-  public class FloatVectorRotateExpression : RotateExpression<List<double>> {
+  public class FloatVectorRotateExpression : RotateExpression<IReadOnlyList<double>> {
     public FloatVectorRotateExpression() { }
     [StorableConstructor]
@@ -182,5 +182,5 @@
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].ROT")]
   [StorableClass]
-  public class BooleanVectorRotateExpression : RotateExpression<List<bool>> {
+  public class BooleanVectorRotateExpression : RotateExpression<IReadOnlyList<bool>> {
     public BooleanVectorRotateExpression() { }
     [StorableConstructor]
@@ -198,5 +198,5 @@
   [PushExpression(StackTypes.StringVector, "STRING[].ROT")]
   [StorableClass]
-  public class StringVectorRotateExpression : RotateExpression<List<string>> {
+  public class StringVectorRotateExpression : RotateExpression<IReadOnlyList<string>> {
     public StringVectorRotateExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15017)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
   using System.Collections.Generic;
 
@@ -6,4 +5,5 @@
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Interpreter;
@@ -17,5 +17,5 @@
 
     protected void Eval(IPushStack<T> stack, IPushStack<long> integerStack) {
-      var index = (int)Math.Abs(integerStack.Pop() % stack.Count);
+      var index = integerStack.Pop().AsInt(stack.Count);
       var item = stack.Pop();
       stack.Insert(index, item);
@@ -87,5 +87,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.SHOVE", StackTypes.Integer)]
+  [PushExpression(StackTypes.Exec, "EXEC.SHOVE", StackTypes.Integer, execIn: 1)]
   [StorableClass]
   public class ExecShoveExpression : ShoveExpression<Expression> {
@@ -153,5 +153,5 @@
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].SHOVE", StackTypes.Integer)]
   [StorableClass]
-  public class IntegerVectorShoveExpression : ShoveExpression<List<long>> {
+  public class IntegerVectorShoveExpression : ShoveExpression<IReadOnlyList<long>> {
     public IntegerVectorShoveExpression() { }
     [StorableConstructor]
@@ -169,5 +169,5 @@
   [PushExpression(StackTypes.FloatVector, "FLOAT[].SHOVE", StackTypes.Integer)]
   [StorableClass]
-  public class FloatVectorShoveExpression : ShoveExpression<List<double>> {
+  public class FloatVectorShoveExpression : ShoveExpression<IReadOnlyList<double>> {
     public FloatVectorShoveExpression() { }
     [StorableConstructor]
@@ -185,5 +185,5 @@
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].SHOVE", StackTypes.Integer)]
   [StorableClass]
-  public class BooleanVectorShoveExpression : ShoveExpression<List<bool>> {
+  public class BooleanVectorShoveExpression : ShoveExpression<IReadOnlyList<bool>> {
     public BooleanVectorShoveExpression() { }
     [StorableConstructor]
@@ -201,5 +201,5 @@
   [PushExpression(StackTypes.StringVector, "STRING[].SHOVE", StackTypes.Integer)]
   [StorableClass]
-  public class StringVectorShoveExpression : ShoveExpression<List<string>> {
+  public class StringVectorShoveExpression : ShoveExpression<IReadOnlyList<string>> {
     public StringVectorShoveExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15017)
@@ -127,5 +127,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].STACKDEPTH", StackTypes.Integer)]
-  public class IntegerVectorStackdepthExpression : StackdepthExpression<List<long>> {
+  public class IntegerVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<long>> {
     public IntegerVectorStackdepthExpression() { }
     [StorableConstructor]
@@ -139,5 +139,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].STACKDEPTH", StackTypes.Integer)]
-  public class FloatVectorStackdepthExpression : StackdepthExpression<List<double>> {
+  public class FloatVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<double>> {
     public FloatVectorStackdepthExpression() { }
     [StorableConstructor]
@@ -150,5 +150,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].STACKDEPTH", StackTypes.Integer)]
-  public class BooleanVectorStackdepthExpression : StackdepthExpression<List<bool>> {
+  public class BooleanVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<bool>> {
     public BooleanVectorStackdepthExpression() { }
     [StorableConstructor]
@@ -162,5 +162,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].STACKDEPTH", StackTypes.Integer)]
-  public class StringVectorStackdepthExpression : StackdepthExpression<List<string>> {
+  public class StringVectorStackdepthExpression : StackdepthExpression<IReadOnlyList<string>> {
     public StringVectorStackdepthExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15017)
@@ -9,5 +9,7 @@
     [Storable]
     public T State { get; protected set; }
+    [NonSerialized]
     private int? hashCode;
+    [NonSerialized]
     private string stringRepresentation;
 
@@ -20,5 +22,12 @@
 
     protected virtual int CalcHashCode() {
-      return State.GetHashCode();
+      var hash = 19 * 31 + GetType().FullName.GetHashCode();
+      hash = hash * 31 + State.GetHashCode();
+
+      return hash;
+    }
+
+    protected virtual string GetStringRepresentation() {
+      return State.ToString();
     }
 
@@ -27,5 +36,5 @@
       get
       {
-        return stringRepresentation ?? (stringRepresentation = State.ToString());
+        return stringRepresentation ?? (stringRepresentation = GetStringRepresentation());
       }
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15017)
@@ -1,11 +1,15 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
   [StorableClass]
+  [Serializable]
   public abstract class StatelessExpression : Expression {
+    [NonSerialized]
     private readonly int hashCode;
 
     protected StatelessExpression() {
-      hashCode = GetType().GetHashCode();
+      hashCode = GetType().FullName.GetHashCode();
     }
 
@@ -17,4 +21,12 @@
     }
 
+    public override string StringRepresentation
+    {
+      get
+      {
+        return ExpressionTable.TypeToAttributeTable[GetType()].ExpressionName;
+      }
+    }
+
     public override bool Equals(object obj) {
       return ReferenceEquals(this, obj) ||
